W_kNumRowsToShow = 5;

--This is where users can drop a item, spell or macro to create a custom list


--
-- Main Options Frame Stuff
--
function WhammyOptionsFrame_OnLoad()
	--W_ShowMessage("frame onload");

	WhammyOptionsFrame:SetWidth( 240 ); --adjust the size of the frame
	WhammyOptionsFrame:SetHeight( 334 );
	
	WhammyOptionsFrame_Heading:SetPoint("TOP", "WhammyOptionsFrame", 0, -10);
	WhammyOptionsFrame_Heading:SetText( W_kOptionsFrameHeading );
	
	WhammyOptionsFrame_Text:SetPoint("TOPLEFT", "WhammyOptionsFrame", 50, -45);
	WhammyOptionsFrame_Text:SetJustifyH("LEFT");
	WhammyOptionsFrame_Text:SetWidth( 200 );
	WhammyOptionsFrame_Text:SetText( W_kOptionsFrameText );
	
	WhammyOptionsFrame_RemoveButton:Disable();
	
	WhammyOptionsFrame_DefaultButton_Text:SetPoint("TOPLEFT", "WhammyOptionsFrame", 8, -276);
	WhammyOptionsFrame_DefaultButton_Text:SetJustifyH("LEFT");
	WhammyOptionsFrame_DefaultButton_Text:SetWidth( 200 )
	WhammyOptionsFrame_DefaultButton_Text:SetText( W_kOptionsFrameDefaultButtonDesc );
	WhammyOptionsFrame_DefaultButton:SetText( W_kOptionsFrameDefaultButtonText );
	
	
	--getglobal(this:GetName().."Text"):SetText("W_kOptionsFrameShowSummaryText");
	WhammyOptionsFrame_Summary_CheckButtonText:SetText( W_kOptionsFrameSummaryCheckboxText );

end

function WhammyOptionsFrame_OnMouseUp() --if we click somewhere else in the frame, deselect any rows
	WhammyOptionsFrame_Listbox_SetSelectedRow( 0 );--when we mouse up in just the frame, de-selected anything selected
end




--
-- DropSlot Stuff
--
function WhammyOptionsFrame_DropSlot_Dropped()
	--see what the cursor is holding  "item"  "spell"  "macro"  "money"  "merchant"
	--W_ShowMessage("Slot Recieved Drag");
	local a,b,c = GetCursorInfo()
	
	if ( a == "item" ) then
		local itemID = b;
		local link = c;
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(itemID);
		W_AddCustomListRow( itemName, "item" );
		
	elseif (a == "spell") then
		local spellSlot = b;
		local spellOrPet = c;
		local spellName, spellRank, whichBook, spellTexture;
		
		if ( spellOrPet == "spell" ) then
			whichBook = BOOKTYPE_SPELL
		else
			whichBook = BOOKTYPE_PET
		end
		
		spellName, spellRank = GetSpellName( spellSlot, whichBook );
		local realSpellName = spellName.."("..spellRank..")"
		W_AddCustomListRow( realSpellName, "spell" );
		
	elseif (a == "macro") then
		local macroId = b;
		
		local macroName, macroTexture, macroBody, localVar = GetMacroInfo( macroId );
		W_AddCustomListRow( macroName, "macro" );
		
	elseif (a == "money") then
		local howMuch = b;
	elseif (a == "merchant") then
		local index = b;
	end

	ClearCursor();
	WhammyOptionsFrame_Listbox_Update();
end

function WhammyOptionsFrame_DropSlot_OnClick()
	--W_ShowMessage("dropslot onclick");
	local a,b,c = GetCursorInfo(); --if we clicked something, then clicked the dropslot, treat it like a drag and drop
	if ( a ) then
		WhammyOptionsFrame_DropSlot_Dropped();
	end
end


function W_Summary_CheckButton_Click( isChecked )
	local frame = WhammySummaryFrame
	if ( frame ) then
		if ( isChecked ) then
			frame:Show();
			W_gSummaryIsVisible = true;
		else
			frame:Hide();
			W_gSummaryIsVisible = false;
		end
	end
end



--
-- Listbox Stuff Custom List
--
function WhammyOptionsFrame_Listbox_OnLoad()
	--WhammyListboxScrollbar:Show()
end

function WhammyOptionsFrame_Listbox_OnShow()
	--W_ShowMessage("Listbox OnShow");
	WhammyOptionsFrame_Listbox_SetSelectedRow( 0 ); --when we unshow and show the window, deselect all rows
end

function WhammyOptionsFrame_Listbox_OnClick( button )
	if ( button == "LeftButton" ) then
		--W_ShowMessage("left button");
		local buttonClicked = this:GetID(); --which button did they click 1-5
		local selectedRow = buttonClicked + FauxScrollFrame_GetOffset( WhammyOptionsFrame_Listbox_Scrollbar ); --which row in the table is this
		WhammyOptionsFrame_Listbox_SetSelectedRow( selectedRow ); --keep track of the actual row in the table that was clicked
	else
		--W_ShowMessage("right button"); ignore right clicks in the list
	end
end

function WhammyOptionsFrame_Listbox_Update()
	local row, rowNumInTable; -- 1 through 5 of our window to scroll
	local sb = WhammyOptionsFrame_Listbox_Scrollbar;  -- a reference to the scrollbar
	local rowOffset = FauxScrollFrame_GetOffset( sb ); -- how far has the scrollbar been scrolled? 1 click = 5 items at this time
	local numRowsInTable = W_GetCustomListTotalRows() --how many rows in table minus the first row which is always Custom List
	local rowHeight = 16
	local lbData;	
	local lbButton;
	local selectedRow = WhammyOptionsFrame_Listbox_GetSelectedRow(); --which row is selected in the listbox
	
	if ( selectedRow > 0 ) then --if something selected, enable the remove button
		WhammyOptionsFrame_RemoveButton:Enable();
	else
		WhammyOptionsFrame_RemoveButton:Disable();
	end

	for buttonNum=1,W_kNumRowsToShow do --walk through the # of buttons to display and either fill them in or hide them
		rowNumInTable = rowOffset + buttonNum; --the index to the actual row num in the table
		lbButton = getglobal("WhammyOptionsFrame_Listbox_Entry"..buttonNum); --the button we are drawing

		if ( rowNumInTable == selectedRow ) then --if the row we are accessing is the selected row, then highlight it
			lbButton:LockHighlight();
		else
			lbButton:UnlockHighlight();
		end
		
		if ( rowNumInTable > numRowsInTable ) then --hide the button if the button we are drawing is > the num of rows in the table
			lbButton:SetText("");
			lbButton:Hide();
		else --there is data in the row in the table, get it and show it
			local thingTable = W_GetCustomListRow( rowNumInTable )
			if ( thingTable ) then --if there is valid data, then show it in the listbox
				local thingName = thingTable[1]; -- the name of the item, spell or macro
				local thingType = thingTable[2]; -- will be item, spell or macro
				--lbData = W_GetCustomListRow( rowNumInTable ); --the data we need to draw in the button we are drawing
				lbButton:SetText( thingName ); --set the button text to the data
				lbButton:Show();
			end
		end
	end

	FauxScrollFrame_Update( sb, numRowsInTable, W_kNumRowsToShow, rowHeight );	-- ScrollFrame update
end

function WhammyOptionsFrame_Listbox_GetSelectedRow()
	local selectedRow = WhammyOptionsFrame_Listbox.selectedRowInTable; --the selected row in the table (note that row 1 is always Custom List)
	
	return selectedRow
end

function WhammyOptionsFrame_Listbox_SetSelectedRow( rowNum )
	WhammyOptionsFrame_Listbox.selectedRowInTable = rowNum;
	WhammyOptionsFrame_Listbox_Update(); --refresh the listbox to show the change
end



---
--- functions dealing with the global custom list
---
function W_GetCustomListRow( rowNum )
	return W_gCustomList[ rowNum ]; --return the row data from the custom list table
end

function W_RemoveCustomListRow( rowNum )
	local removedItem = table.remove( W_gCustomList, rowNum ); --remove the row from the listbox data table
end

function W_AddCustomListRow( rowData, thingType ) --thingtype is item, spell or macro
	local thingTable = {rowData, thingType};
	table.insert( W_gCustomList, thingTable );
end

function W_GetCustomListTotalRows()
	local totalRows = table.getn( W_gCustomList ); --how many rows in the custom list table
	
	if ( totalRows ) then
		return totalRows;
	else
		return 0;
	end
end



--
-- Remove Button Stuff
--
function WhammyOptionsFrame_RemoveButton_OnClick()
	--W_ShowMessage("Remove button Click");
	
	local selectedRow = WhammyOptionsFrame_Listbox_GetSelectedRow(); --the selected row in the table

	W_RemoveCustomListRow( selectedRow ); --remove the row from the listbox data table, row 1 is always Custom List
	
	WhammyOptionsFrame_Listbox_SetSelectedRow( 0 ) --we removed the selected row, so set this to 0
	WhammyOptionsFrame_Listbox_Update(); --refresh the listbox to show the change
end

--
-- Default Button Stuff
-- handle clicking the set defaults button - need to add an Are You Sure dialog
function WhammyOptionsFrame_DefaultButton_OnClick() --clicking the button sets the spells back to their defaults
	--W_ShowMessage("Button click");
	
	W_Set_Saved_Spells(); --set the saved spell table to the default spells for this type of char (priest, mage etc)
	
	for i = 1,W_kMaxDropDownButtons do --now walk through the buttons and set their text
		local dropDownName = "W_DropDown"..i --each drop down
		local ddFrame = getglobal( dropDownName ); -- and the drop down frame
		local spellName = W_gSavedSpells[dropDownName]; -- and the spells that we want to default the drop down to
		--W_ShowMessage( dropDownName.." = "..spellName );
		UIDropDownMenu_SetSelectedName( ddFrame, spellName); --set the selected item in the list
		UIDropDownMenu_SetText( spellName, ddFrame ); --also put the name of the spell in the text area
	end
	
	W_Update_Unit_Buttons();
	
	-- set the health value drop down to default
	UIDropDownMenu_SetSelectedName( W_Health_DropDown, "Off" ); --set the dropdown selection
	W_gHealthLevel = "Off"
end
