function W_Summary_Button_Click()
	W_ShowMessage("summary button clicked");
end


function W_Summary_Frame_Onload(self)
	-- Register the game events neccesary for our functionality
	--self:RegisterEvent("ADDON_LOADED");
end

function W_Summary_Frame_MouseDown(self)
	--W_ShowMessage("Summary_Frame_MouseDown");
	
	if arg1 == "LeftButton" then -- drag the frame
		self:StartMoving();
	end
end

-- called when there is a health changed event to update the party/raid total health bar
function W_Update_Total_Health()
	local bar = WhammySummaryFrame_HealthBar
	local maxHealthBarWidth = 100; --the actual width in pixels of the raid health bar
	local numRaidMembers = GetNumRaidMembers();
	local numPartyMembers = GetNumPartyMembers();
	local currentUnitHealth, maxUnitHealth, healthFraction, healthFractionTotal, totalFraction, numMembers = 0,0,0,0,0,0;
	
	if ( numRaidMembers == 0 and numPartyMembers == 0 ) then -- player is alone
		currentUnitHealth = UnitHealth( "player" ); --get the current player unit health
		maxUnitHealth = UnitHealthMax( "player" ); --get the units max health
		healthFraction = currentUnitHealth / maxUnitHealth; -- what % health is this unit
		healthFractionTotal = healthFractionTotal + healthFraction
		numMembers = 1;
	else --player is either in a party or a raid
		if ( numRaidMembers == 0 ) then --not in a raid, just in a party, we need to get the player health, then add in the rest of the party
			currentUnitHealth = UnitHealth( "player" ); --get the current player unit health
			maxUnitHealth = UnitHealthMax( "player" ); --get the units max health
			healthFraction = currentUnitHealth / maxUnitHealth; -- what % health is this unit
			healthFractionTotal = healthFractionTotal + healthFraction;
			numMembers = numPartyMembers + 1;
						
			for id = 1,numPartyMembers do
				currentUnitHealth = UnitHealth( "party"..id ); --get the current unit health
				maxUnitHealth = UnitHealthMax( "party"..id ); --get the units max health
				healthFraction = currentUnitHealth / maxUnitHealth; -- what % health is this unit
				healthFractionTotal = healthFractionTotal + healthFraction;
			end
		else
			numMembers = numRaidMembers;
			for id = 1,numRaidMembers do
				currentUnitHealth = UnitHealth( "raid"..id ); --get the current unit health
				maxUnitHealth = UnitHealthMax( "raid"..id ); --get the units max health
				healthFraction = currentUnitHealth / maxUnitHealth; -- what % health is this unit
				healthFractionTotal = healthFractionTotal + healthFraction;
			end
		end
	end
	
	totalFraction = healthFractionTotal / numMembers
	healthBarAmount = maxHealthBarWidth * totalFraction;
	bar:SetWidth( healthBarAmount ); -- set the raid health bar to the raid health amount
end

function W_Handle_Unit_Mana_Event()
	local bar = WhammySummaryFrame_ManaBar
	local maxManaBarWidth = 100; --the actual width in pixels of the raid health bar
	local numRaidMembers = GetNumRaidMembers();
	local numPartyMembers = GetNumPartyMembers();
	local currentUnitMana, maxUnitMana, manaFraction, manaFractionTotal, totalFraction, numMembers, unitCount = 0,0,0,0,0,0,0;
	local kMana = 0; -- power type, mana=0, rage=1, focus=2(hunterpets), energy=3, happiness=4
	
	if ( numRaidMembers == 0 and numPartyMembers == 0 ) then -- player is alone
		currentUnitMana = UnitMana( "player" ); --get the current player unit mana
		maxUnitMana = UnitManaMax( "player" ); --get the units max mana
		manaFraction = currentUnitMana / maxUnitMana; -- what % mana is this unit
		manaFractionTotal = manaFractionTotal + manaFraction
		if ( UnitPowerType("player") == kMana ) then
			unitCount = 1;
		end
	else --player is either in a party or a raid
		if ( numRaidMembers == 0 ) then --not in a raid, just in a party, we need to get the player mana, then add in the rest of the party
			if ( UnitPowerType( "player" ) == kMana ) then --we only care about units that use mana
				currentUnitMana = UnitMana( "player" ); --get the current player unit mana
				maxUnitMana = UnitManaMax( "player" ); --get the units max mana
				manaFraction = currentUnitMana / maxUnitMana; -- what % mana is this unit
				manaFractionTotal = manaFractionTotal + manaFraction;
				unitCount = 1;
			end
					
			for id = 1,numPartyMembers do
				entity = "party"..id
				if ( UnitPowerType( entity ) == kMana ) then --we only care about units that use mana
					currentUnitMana = UnitMana( entity ); --get the current unit mana
					maxUnitMana = UnitManaMax( entity ); --get the units max mana
					manaFraction = currentUnitMana / maxUnitMana; -- what % mana is this unit
					manaFractionTotal = manaFractionTotal + manaFraction;
					unitCount = unitCount + 1;
				end
			end
		else
			numMembers = numRaidMembers;
			for id = 1,numRaidMembers do
				entity =  "raid"..id
				if ( UnitPowerType( entity ) == kMana ) then --we only care about units that use mana
					currentUnitMana = UnitMana( entity ); --get the current unit mana
					maxUnitMana = UnitManaMax( entity ); --get the units max mana
					manaFraction = currentUnitMana/ maxUnitMana; -- what % mana is this unit
					manaFractionTotal = manaFractionTotal + manaFraction;
					unitCount = unitCount + 1;
				end
			end
		end
	end
	
	if ( unitCount > 0 ) then -- if unit count = 0 then this player is alone and does not use mana, so the mana bar will just reset to full width
		totalFraction = manaFractionTotal / unitCount;
		manaBarAmount = maxManaBarWidth * totalFraction;
		bar:SetWidth( manaBarAmount ); -- set the raid mana bar to the raid mana amount
	else
		bar:SetWidth( maxManaBarWidth ); -- set the raid mana bar to the raid mana amount
	end
end
